/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		drیӋ@\Pʕײ
 *
 * \par pLq:
 *		AVR456: SB201̧ѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: $
 * $Date		: $  \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

/******************************************************************************
 ݸٰ ̧
******************************************************************************/
#include "common.h"
#include "battery_protection.h"

/******************************************************************************
 ϐ
******************************************************************************/
bool batteryProtectionTriggered = false;
uint8_t chargeProtectionCounter = 0;

/******************************************************************************
 荞݊֐錾
******************************************************************************/
#pragma vector = BPINT_vect
__interrupt void BATTPROT_BatteryProtection_ISR(void)
{
	batteryProtectionTriggered = true;

	// HZoꂽꍇA
	if( BPIFR & (1<<SCIF) )
	{
		// TODO: W(ċ)[łȂꍇɉHZɒǉĂB
	}

	// dߓdoꂽꍇA
	if( BPIFR & (1<<DOCIF) )
	{
		// TODO: W(ċ)[łȂꍇɕdߓdɒǉĂB
	}

	// [dߓdoꂽꍇA
	if( BPIFR & (1<<COCIF) )
	{
		// TODO: W(ċ)[łȂꍇɏ[dߓdɒǉĂB
		chargeProtectionCounter++;
	}

	// ddoꂽꍇA
	if( BPIFR & (1<<DHCIF) )
	{
		// TODO: W(ċ)[łȂꍇɕddɒǉĂB
		chargeProtectionCounter++;
	}

	// [ddoꂽꍇA
	if( BPIFR & (1<<CHCIF) )
	{
		// TODO: W(ċ)[łȂꍇɏ[ddɒǉĂB
	}

	// SĂ̓drی슄荞ݗv׸ނ
	BPIFR = (1<<SCIF)|(1<<DOCIF)|(1<<COCIF)|(1<<DHCIF)|(1<<CHCIF);
}

/******************************************************************************
 ֐錾
******************************************************************************/

/******************************************************************************/
/*! \brief HZdoƔԂݒ
 *
 *	\param	dischargingLevel	AŐݒ肷񋓎q^
 *	\param	reacTime			ݸ ڼ޽ɏl(\ref BATTPROT_ScrtUsecToHex)
 *
 *	\retval	Ȃ
 */
void BATTPROT_SetShortCircuitDetection( uint8_t dischargingLevel, uint8_t reacTime )
{
	BPSCTR = reacTime;
	BPSCD = dischargingLevel;
}

/******************************************************************************/
/*! \brief d/[dߓdoƔԂݒ
 *
 *	\param	dischargingLevel	AŐݒ肷񋓎q^
 *	\param	chargingLevel	 	AŐݒ肷񋓎q^
 *	\param	reacTime			ݸ ڼ޽ɏl(\ref BATTPROT_OcrtMsecToHex)
 *
 *	\retval	Ȃ
 */
void BATTPROT_SetOverCurrentDetection( uint8_t dischargingLevel, uint8_t chargingLevel, uint8_t reacTime )
{
	BPOCTR = reacTime;
	BPDOCD = dischargingLevel;
	BPCOCD = chargingLevel;
}

/******************************************************************************/
/*! \brief [ddoƔԂݒ
 *
 *	\param	dischargingLevel	AŐݒ肷񋓎q^
 *	\param	chargingLevel		AŐݒ肷񋓎q^
 *	\param	reacTime			ݸ ڼ޽ɏl(\ref BATTPROT_HcrtMsecToHex)
 *
 *	\retval	Ȃ
 */
void BATTPROT_SetHighCurrentDetection( uint8_t dischargingLevel, uint8_t chargingLevel, uint8_t reacTime )
{
	BPHCTR = reacTime;
	BPDHCD = dischargingLevel;
	BPCHCD = chargingLevel;
}

/******************************************************************************/
/*! \brief drیݒ{(ؾĂɂĂ̂݉)
 *
 *	\retval	Ȃ
 */
void BATTPROT_LockBatteryProtectionConfig( void )
{
	uint8_t temp = (0<<BPPLE)|(1<<BPPL);
	BPPLR = (1<<BPPLE)|(1<<BPPL);
	BPPLR = temp;
}

/******************************************************************************/
/*! \brief drی삪Nꂽ
 *
 * drیPʕHZAߓdAdoB^Ԃꍇ
 * oNĂ܂BoN𒲂ׂ邱ƂɂAo׸ނ
 * ܂B
 *
 *	\retval	ްْl͓drی삪Nꂽꍇɐ^AȂ΋UԂ܂B
 */
bool BATTPROT_IsProtectionTriggered( void )
{
	bool temp = batteryProtectionTriggered;

	batteryProtectionTriggered = false;
	return temp;
}

/******************************************************************************/
/*! \brief [dیv
 *
 */
void BATTPROT_ClearChargeProtectionCounter( void )
{
	uint8_t interruptState = __save_interrupt();

	__disable_interrupt();
	chargeProtectionCounter = 0;
	__restore_interrupt(interruptState);
}

/******************************************************************************/
/*! \brief [dیv擾
 *
 */
uint8_t BATTPROT_GetChargeProtectionCounter( void )
{
	uint8_t ret;

	uint8_t interruptState = __save_interrupt();

	__disable_interrupt();
	ret = chargeProtectionCounter;
	__restore_interrupt(interruptState);

	return ret;
}
