/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		CCADCPʕͯ ̧
 *
 *		݌vADC(CCADC)ł̌`Ԑݒƍ̎pPʕ
 *
 * \par pLq:
 *		AVR456: SB201̧ѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: 3111 $
 * $Date		: 2008N118 16:58:29 +0100 (fr, 18 jan 2008) $
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *****************************************************************************/

#ifndef CCADC_H
#define CCADC_H

/******************************************************************************
 ݸٰ
******************************************************************************/
#include "common.h"
#include "battery_pack_parameters.h"

/******************************************************************************
 `
******************************************************************************/

/*! \brief CC-ADC` */
typedef enum CCADC_modes_enum{
	CCADC_DISABLE = 0,		//!< CC-ADC֎~A荞݂֎~ĉ
	CCADC_IAC = 1,			//!< CC_ADCAudƗݐϓd̗ϊ荞݂𐶐
	CCADC_ICC = 2,			//!< CC_ADCAudϊ荞݂𐶐
	CCADC_ACC = 3,			//!< CC_ADCAݐϓdϊ荞݂𐶐
	CCADC_RCC = 4			//!< d܂B- ɂėݐϊ킪֎~ĉ邱ƂɒӂĂB
} CCADC_modes_t;

/*! \brief CC-ADCݐϓdϊ - ms */
typedef enum CCADC_AccConversionPeriod_enum{
	ACCT_128 = ( (0<<CADAS1)|(0<<CADAS0) ),		//!<  16K (16384) ULPɑ
	ACCT_256 = ( (0<<CADAS1)|(1<<CADAS0) ),		//!<  32K (32768) ULPɑ
	ACCT_512 = ( (1<<CADAS1)|(0<<CADAS0) ),		//!<  64K (65536) ULPɑ
	ACCT_1024 = ( (1<<CADAS1)|(1<<CADAS0) )		//!< 128K(131072) ULPɑ
}CCADC_AccConvPeriod_t;

/*! \brief CC-ADCd̎Ԋu - ms */
typedef enum CCADC_RccConversionPeriod_enum{
	RCCI_256 = ( (0<<CADSI1)|(0<<CADSI0) ),		//!<  32K (32768) ULPɑ
	RCCI_512 = ( (0<<CADSI1)|(1<<CADSI0) ),		//!<  64K (65536) ULPɑ
	RCCI_1024 = ( (1<<CADSI1)|(0<<CADSI0) ),	//!<  128K(131072) ULPɑ
	RCCI_2048 = ( (1<<CADSI1)|(1<<CADSI0) )		//!<  256K(262144) ULPɑ
}CCADC_RccConvPeriod_t;

// ̒`
#define CCADC_POLARITY_POS				(0<<CADPOL)
#define CCADC_POLARITY_NEG				(1<<CADPOL)

/*! CC-ADC̋ɐ̏ꍇɐ^ȀꍇɋU */
#define CCADC_IS_POLARITY_NEGATIVE()	(CADCSRA & (1<<CADPOL))

/******************************************************************************
 ֐^錾
******************************************************************************/
void CCADC_Init( CCADC_AccConvPeriod_t accConversionTime, CCADC_RccConvPeriod_t rccSamplingInterval, uint16_t regularCurrentLevel );
void CCADC_SetMode( CCADC_modes_t mode );
uint8_t CCADC_GetMode( void );
int32_t CCADC_GetAccResult( void );
int32_t CCADC_GetIccResult( void );
bool CCADC_isAccResultReady( void );
bool CCADC_isIccResultReady( void );
bool CCADC_GetPolarityChange( void );

int16_t CCADC_GetRawAccOffset( void );
int16_t CCADC_GetAccOffset( void );
void CCADC_CalculateAccOffset( void );

#endif // CCADC_H
