/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		RCU̍ZƸۯp֐
 *
 * \par pLq:
 *		AVR456: SB201̧ѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: $
 * $Date		: $  \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

/******************************************************************************
 ݸٰ ̧
******************************************************************************/
#include "common.h"
#include "rc_calibration.h"
#include "ATmega8HVA_16HVA_signature.h"

/******************************************************************************
 I֐p^錾
******************************************************************************/
void RCCAL_StopTimer0();
void RCCAL_StartOSIsampleClockPeriod(uint8_t clock_source);

/******************************************************************************
 َ̧ϐ
******************************************************************************/
RCCAL_CalibState_t RCCAL_CalibState;
RCCAL_IC_State_t RCCAL_IC_State;

int16_t LastICResult;

/******************************************************************************/
/*! \brief ᑬRCԌvZ
 *
 *	^ꂽxŒᑬRCԂvZ܂BᑬRČvZp̎ް
 *	ƉpLqŋLq悤Ɏۂ̎vẐ([񂩂ǂ܂)
 *	[ްƋɎg܂Bʂms~1024łB]āA10̏ޯĂ
 *	16ޯČŒ菬_`AA0x XXXX XX.xx xxxx xxxxłmsƂČ܂B
 *
 *	\param	temperature	݂ł̉x
 *
 *	\return	ms~1024ł̒ᑬRC
 */
uint16_t RCCAL_CalculateSlowRCperiod(int16_t temperature)
{
	uint16_t slow_RC_period;
	int16_t  slow_RC_temperature_coeff;
	uint16_t calib_temperature;

	// [񂩂Kvްǂݍ݁Bx͂̎ɍXȂ鏑݂ɑ
	// Ď{̂ŁAȌ݂6SPMCSRڼ޽𱸾̂
	// 邽߂łB
	slow_RC_period = READ_SIGNATUREBYTE(SIG_SLOW_RC_L);

	__delay_cycles(2);		// O݂6łSPMCSRڼ޽ւ̏݉
	slow_RC_period |= READ_SIGNATUREBYTE(SIG_SLOW_RC_H) << 8;

	__delay_cycles(2);		// O݂6łSPMCSRڼ޽ւ̏݉
	slow_RC_temperature_coeff = READ_SIGNATUREBYTE(SIG_SLOW_RC_PRED_L);

	__delay_cycles(2);		// O݂6łSPMCSRڼ޽ւ̏݉
	slow_RC_temperature_coeff |= READ_SIGNATUREBYTE(SIG_SLOW_RC_PRED_H) << 8;

	__delay_cycles(2);		// O݂6łSPMCSRڼ޽ւ̏݉
	calib_temperature = READ_SIGNATUREBYTE(SIG_TEMPERATURE_HOT) + ZERO_KELVIN;

	return (uint16_t)(slow_RC_period - ((temperature - calib_temperature)*slow_RC_temperature_coeff)/64);
}

/******************************************************************************/
/*! \brief RCZJn
 */
void RCCAL_StartCalibrateFastRC()
{
	RCCAL_CalibState = RCCAL_CALIB_INIT;
}

/******************************************************************************/
/*! \brief sɒᑬRCUɑ΂čRCZ
 *
 *	l݂ɋ߂߁As܂BFOSCCALƂ1
 *	̋܂BAɒB鎞̎gł̔т
 *	邽߁AFOSC掯[޲ĂgA]Ă蒷p͈͂^܂B
 *	FOSCFOSCCAL̍ŒlႢg^Ő̍ŏ
 *	lłB̒A܂͊̒ɒBꍇAFOSCCALlI
 *	сA͈̔͂SxɓnFOSCCAL𒲐߂̂ɏ[Ȕ͈͂𒴂Ē񋟂
 *	ׂŁÂɉsȂ߁AsԂ܂B
 *
 *	̋E͍s܂񂪁AႦFOSCCALl͈͊OłAǧʂ
 *	̔тɏoƂĂAg͐ZׂłBFOSCCALl
 *	FOSCCALł̍ŒlFOSCԂ̏ꍇA͈͓̔̒lI΂邩
 *	܂B
 *
 *  \note ֐""̊ԂɈႤcal_RC_periodŌĂ΂ȂłBZɒ
 *		  RCςꍇA̕ϐď邽߂
 *		  RCCAL_StartCalibrateFastRC()đsĂB
 *	
 *	\param	cal_RC_period	ms~1024ł̒ᑬRC
 */
void RCCAL_CalibrateFastRCruntime(uint16_t cal_RC_period)
{
	static uint8_t fosccal_segment;
	static uint8_t fosccal_default;
	static int16_t error;
	static int16_t last_error;
	static uint8_t fosccal_saved;

	switch(RCCAL_CalibState) {
	case RCCAL_CALIB_INIT:
		// [񂩂Kvްǂݍ݁Bx͂̎ɍXȂ鏑
		// ɑ΂Ď{̂ŁAȌ݂6SPMCSRڼ޽𱸾
		// ̂邽߂łB
		fosccal_default = READ_SIGNATUREBYTE(SIG_FOSCCAL_DEFAULT);
		__delay_cycles(2);		// O݂6łSPMCSRڼ޽ւ̏݉
		fosccal_segment = READ_SIGNATUREBYTE(SIG_FOSC_SEGMENT);
		
		RCCAL_StartOSIsampleClockPeriod(SLOW_RC);
		RCCAL_CalibState = RCCAL_CALIB_WORKING;

		last_error = 32767;		// last_error͉xύXɖ
		break;

	case RCCAL_CALIB_WORKING:
		{
			if(RCCAL_IC_FINISHED == RCCAL_IC_State) {
				uint8_t bottom_limit = fosccal_segment & 0xE0;
				uint8_t top_limit =  (fosccal_default & 0xE0) + 0x1F;

				uint16_t target_period = cal_RC_period * FAST_RC_TARGET_MHZ;	// MHzŜvZ

				error = LastICResult - target_period;

				// Ō̌덷̐Βľ݂덷̐ΒlꍇAŌ̌FOSCCALlgp
				// (͗Ⴆ-4̌덷+5̌덷֍sɒu܂B)
				if(last_error < 0 && error > 0) {
					if(-last_error < error) {
						FOSCCAL = fosccal_saved;
						RCCAL_CalibState = RCCAL_CALIB_FINISHED;
						break;
					}
				}
				if(last_error > 0 && error < 0) {
					if(last_error < -error) {
						FOSCCAL = fosccal_saved;
						RCCAL_CalibState = RCCAL_CALIB_FINISHED;
						break;
					}
				}

				if(error > 0) {
					// 
					uint8_t check_value = bottom_limit + 0x1F;
					last_error = error;
					fosccal_saved = FOSCCAL;
					if ( FOSCCAL-- == check_value ) {
						FOSCCAL = fosccal_segment;			// ֍sɎgłiK邽FOSCCALgp
					} else if (FOSCCAL < bottom_limit) {
						FOSCCAL = fosccal_default;			// ȂŔ͈͂ÂɊFOSCCALlI
						RCCAL_CalibState = RCCAL_CALIB_FAILURE;
					}
					RCCAL_StartOSIsampleClockPeriod(SLOW_RC);

				} else if (error < 0) {
					// 
					uint8_t check_value = fosccal_segment + 0x01;
					last_error = error;
					fosccal_saved = FOSCCAL;
					if ( FOSCCAL++ == check_value ) {
						FOSCCAL = fosccal_default & 0xE0;	// 㑤֍sɎgłiK邽FOSCCALgp
					} else if ( FOSCCAL > top_limit ) {
						FOSCCAL = fosccal_default;			// ȂŔ͈͂ÂɊFOSCCALlI
						RCCAL_CalibState = RCCAL_CALIB_FAILURE;
					}
					RCCAL_StartOSIsampleClockPeriod(SLOW_RC);

				} else {
					// 덷0ɓÂɂ̒lŒ~
					RCCAL_CalibState = RCCAL_CALIB_FINISHED;
					break;
				}
			}
		}
		break;

	default:
		// ȂُȂA炭ZI܂B
		break;
	}
}

/***********************************************************/
/*! \brief RCŽݏ󋵂Ԃ܂B
 */
RCCAL_CalibState_t RCCAL_GetState()
{
	return RCCAL_CalibState;
}

/******************************************************************************/
/*! \brief OSIOuꂽ۸𑪒
 *
 *	U̪̎̑OuꂽۯRC_CALIB_CYCLESōRCۯ
 *	𑪒肵܂BOuATmega16HVAɑ΂128osi_cycles͑\I8ŁA
 *	I񂾓͸ۯɑ΂čv1024^܂Bp\ȓ͂͒ᑬRCULP RC
 *	łB
 *
 *	x: ٰ݂OCR01̈ꂾÂɍZɎg鍂RC
 *	2^16ł邱ƂmɂĂB
 *
 *	\param	clock_source	gۯ(ᑬRC܂ULP RC)
 */
void RCCAL_StartOSIsampleClockPeriod(uint8_t clock_source)
{
	OSICSR = clock_source | (1 << OSIEN);	// OSIƑI
	TCCR0A = (1 << TCW0) | (1 << ICEN0) | (0 << ICS0) | (1<<ICES0);	// 16ޯēA~[N
	TCCR0B = T0_PRESCALER;					// v0͑OuȂős
	TIFR0 |= (1 << ICF0);					// Oɐݒ肳ĂꍇɊ荞׸ނ
	TIMSK0 |= (1<<ICIE0);					// ߊl荞݋

	TCNT0 = 0;								// 邽߂Ɍv

	RCCAL_IC_State = RCCAL_IC_INITIAL_CAPTURE;
}

/******************************************************/
/*! \brief v0ߊlp荞ٰ
 *
 *	U̪̎̑OuꂽۯRC_CALIB_CYCLESōRCۯ
 *	𑪒肵܂BOuATmega16HVAɑ΂128osi_cycles͑\I8ŁA
 *	I񂾓͸ۯɑ΂čv1024^܂Bp\ȓ͂͒ᑬRCULP RC
 *	łB
 *
 *	x: ٰ݂OCR01̈ꂾÂɍZɎg鍂RC
 *	2^16ł邱ƂmɂĂB
 */
#pragma vector=TIMER0_IC_vect
__interrupt void RCCAL_InputCapture_ISR()
{
	static uint8_t i = 0;
	static uint16_t initial_capture, final_capture;

	if(RCCAL_IC_INITIAL_CAPTURE == RCCAL_IC_State ) {
		i = 0;
		initial_capture = OCR0A;
		initial_capture |= OCR0B << 8;
		RCCAL_IC_State = RCCAL_IC_CAPTURES;

	} else {
		++i;
		if(i == RC_CALIB_CYCLES) {
			final_capture = OCR0A;
			final_capture |= OCR0B << 8;
			LastICResult = final_capture - initial_capture;
			RCCAL_IC_State = RCCAL_IC_FINISHED;
			TIMSK0 &= ~(1<<ICIE0);
		}
	}
}
