/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		rc_calibration.cp`ƌ^錾
 *
 * \par pLq:
 *		AVR456: SB201̧ѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: 2700 $
 * $URL			: http://svn.norway.atmel.com/AppsAVR8/avr351_hva_runtime_rc_calib/trunk/code/RC_calib_oscsampleif.h $
 * $Date		: 2007N1113 11:04:17 +0100 (ti, 13 nov 2007) $  \n
 ******************************************************************************/

#include "common.h"

#ifndef RC_CALIB_H
#define RC_CALIB_H

/******************************************************************************
 `
******************************************************************************/

// v0pOuB0OFF

typedef enum TIM0_prescaler_enum{
	T0_PRESCALER_0 = ((0 << CS02)|(0 << CS01)|(0 << CS00)),
	T0_PRESCALER_1 = ((0 << CS02)|(0 << CS01)|(1 << CS00)),
	T0_PRESCALER_8 = ((0 << CS02)|(1 << CS01)|(0 << CS00)),
	T0_PRESCALER_64 = ((0 << CS02)|(1 << CS01)|(1 << CS00)),
	T0_PRESCALER_256 = ((1 << CS02)|(0 << CS01)|(0 << CS00)),
	T0_PRESCALER_1024 = ((1 << CS02)|(0 << CS01)|(1 << CS00))
} TIM0_prescaler_t;

#define T0_PRESCALER (T0_PRESCALER_1)

//! Hzł̼ ۯg
#define FAST_RC_TARGET_MHZ			SYSTEM_CLK_MHz	//!< Hzł̍RCڕWgB݊SMHzłe
#define SLOW_RC_NOMINAL_PERIOD		(7813)			//!< 2^10ŎړxꂽᑬRCUp̎(1/131072)
//#define SLOW_RC_NOMINAL_PERIOD	(15625)			//!< 2^11ŎړxꂽᑬRCUp̎(1/131072)
#define FAST_RC_SEGMENT_BIT			(5)				//!< ͈͂߂FOSCCALޯāB挟Ɏgp
#define FAST_RC_NO_SEGMENTS			(256/(1 << FAST_RC_SEGMENT_BIT))	//!< RCł̋搔
#define MAX_FAST_RC_ERROR			(10)			//!< 0.1%ł̍RCő勖e덷AA101%

#define RC_CALIB_CYCLES				(8)				//!< OSIZpZ

#define SLOW_RC 					(1 << OSISEL0)	//!< RCZIp
#define ULP_RC						(0 << OSISEL0)	//!< RCZIp

typedef enum {
	RCCAL_CALIB_INIT,
	RCCAL_CALIB_WORKING,
	RCCAL_CALIB_FINISHED,
	RCCAL_CALIB_FAILURE
} RCCAL_CalibState_t;

typedef enum {
	RCCAL_IC_INITIAL_CAPTURE,
	RCCAL_IC_CAPTURES,
	RCCAL_IC_FINISHED
} RCCAL_IC_State_t;

/***********************
 ֐lϸ
************************/
//! Zs(Aߊl荞݂Ă邩?)
#define RCCAL_IS_RUNNING() (TIMSK0 & (1<<ICIE0))

/******************************************************************************
 ֐^錾
******************************************************************************/
uint16_t RCCAL_CalculateSlowRCperiod(int16_t temperature);
// gȂߒ߉
//uint16_t RCCAL_MeasureULPRCperiod(uint16_t cal_RC_period);
void RCCAL_StartCalibrateFastRC();
void RCCAL_CalibrateFastRCruntime(uint16_t cal_RC_period);

RCCAL_CalibState_t RCCAL_GetState();

#endif // RC_CALIB_H
