/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief 
 *		Routines for SHA-2SHA-2 HMACpٰ
 *
 * \par pLq:
 *		AVRxxx: SHA-2@\SHA-2ÂHMAC
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: xxxx $
 * $Date		: 2008N422 18:38:15 +0100 (on, 12 des 2007) $  \n
 *
 * 쌠 (c) 2008, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

/* ݸٰ */
#include "HMAC-SHA2.h"
#include "stdint.h"

/* ّ̧Sϐ */

unsigned long K[64] = { 0x428a2f98L, 0x71374491L, 0xb5c0fbcfL, 0xe9b5dba5L,		//!< SHA-2p64Kl܂ް\
						0x3956c25bL, 0x59f111f1L, 0x923f82a4L, 0xab1c5ed5L,
						0xd807aa98L, 0x12835b01L, 0x243185beL, 0x550c7dc3L,
						0x72be5d74L, 0x80deb1feL, 0x9bdc06a7L, 0xc19bf174L,
						0xe49b69c1L, 0xefbe4786L, 0x0fc19dc6L, 0x240ca1ccL,
						0x2de92c6fL, 0x4a7484aaL, 0x5cb0a9dcL, 0x76f988daL,
						0x983e5152L, 0xa831c66dL, 0xb00327c8L, 0xbf597fc7L,
						0xc6e00bf3L, 0xd5a79147L, 0x06ca6351L, 0x14292967L,

						0x27b70a85L, 0x2e1b2138L, 0x4d2c6dfcL, 0x53380d13L,
						0x650a7354L, 0x766a0abbL, 0x81c2c92eL, 0x92722c85L,
						0xa2bfe8a1L, 0xa81a664bL, 0xc24b8b70L, 0xc76c51a3L,
						0xd192e819L, 0xd6990624L, 0xf40e3585L, 0x106aa070L,
						0x19a4c116L, 0x1e376c08L, 0x2748774cL, 0x34b0bcb5L,
						0x391c0cb3L, 0x4ed8aa4aL, 0x5b9cca4fL, 0x682e6ff3L,
						0x748f82eeL, 0x78a5636fL, 0x84c87814L, 0x8cc70208L,
						0x90befffaL, 0xa4506cebL, 0xbef9a3f7L, 0xc67178f2L};

/* ` */
#define a	ul_working[0]	//!< SHA-2vZ'a'i[̂Ɏgϐ
#define b	ul_working[1]	//!< SHA-2vZ'b'i[̂Ɏgϐ
#define c	ul_working[2]	//!< SHA-2vZ'c'i[̂Ɏgϐ
#define d	ul_working[3]	//!< SHA-2vZ'd'i[̂Ɏgϐ
#define e	ul_working[4]	//!< SHA-2vZ'e'i[̂Ɏgϐ
#define f	ul_working[5]	//!< SHA-2vZ'f'i[̂Ɏgϐ
#define g	ul_working[6]	//!< SHA-2vZ'g'i[̂Ɏgϐ
#define h	ul_working[7]	//!< SHA-2vZ'h'i[̂Ɏgϐ

#define ROTR(x, n) ( (x >> n) | (x << (32-n)) )		//!< E]֐`(̎ޗʂRAMgp؂l߁Ax𑝂܂B)
#define ROTL(x, n) ( (x << n) | (x >> (32-n)) )		//!< ]֐`(̎ޗʂRAMgp؂l߁Ax𑝂܂B)

/**** ֐ */

/*! \brief ްSWHA-2s
 *
 * \param	message	SHA-2ٰ݂ւ̓ް܂ްzA1632ޯČ
 * \param	seed	a,b,`hlpl܂ްzA832ޯČ
 */

void SHA_2(unsigned long *ul_message, unsigned long *ul_working)
{
	uint8_t uc_temp, s;					//!< ꎞްL/vƂĎgϐ
	static unsigned long ul_temp[8];	//!< ŏI(Hj(i)=a+Hj(i-1))pްi[Ɏgp(ɒû邽߂static)
	static unsigned long t1 , t2;		//!< ꎞϐAgp邽߂static

	// (Hj(i)=a+Hj(i-1))sł悤ɂėSĂ̎ްꎞLɕ
	for(uc_temp = 0; uc_temp < 8; uc_temp++)
	{
		ul_temp[uc_temp] = ul_working[uc_temp];
	}

	// 16̓͒lSĂɓnČJԂARAMߖ񂷂邽߂ɎsɓWJ
	for(uc_temp = 0; uc_temp < 64; uc_temp++)
	{
		s = uc_temp & 0x0F;		// RAMԂߖ񂷂邽߁AQƒɎg߂ɉʑ4ޯĂ𕪗
		if(uc_temp >= 16)
		{
			// Wikipedia̋^ނ: "s0 := (w[i-15] rightrotate 7) xor (w[i-15] rightrotate 18) xor (w[i-15] rightshift 3)"
			t1 = ROTR(ul_message[(s - 15) & 0x0F] , 7) ^ ROTL(ul_message[(s - 15) & 0x0F] , (32-18)) ^ (ul_message[(s - 15) & 0x0F] >> 3);
//			t1 = ROTR(ul_message[(s - 15)] , 7) ^ ROTL(ul_message[(s - 15)] , (32-18)) ^ (ul_message[(s - 15)] >> 3);
			// Wikipedia̋^ނ: "s1 := (w[i-2] rightrotate 17) xor (w[i-2] rightrotate 19) xor (w[i-2] rightshift 10)"
			t2 = ROTL(ul_message[(s - 2) & 0x0F] , (32-17)) ^ ROTL(ul_message[(s - 2) & 0x0F] , (32-19)) ^ (ul_message[(s - 2) & 0x0F] >> 10);
			// Wikipedia̋^ނ: "w[i] := w[i-16] + s0 + w[i-7] + s1"
			ul_message[s] = ul_message[s] + t1 + ul_message[(s - 7) & 0x0F] + t2;		
		}

		t2 = ROTR(a,2) ^ ROTR(a,13) ^ ROTL(a,(32-22));	// Wikipedia̋^ނ: "s0 := (a rightrotate 2) xor (a rightrotate 13) xor (a rightrotate 22)"
		t2 += (a & b) ^ (a & c) ^ (b & c);				// Wikipedia̋^ނ: "maj := (a and b) xor (a and c) xor (b and c)"
		t1 = ROTR(e,6) ^ ROTR(e,11) ^ ROTL(e,(32-25));	// Wikipedia̋^ނ: "s1 := (e rightrotate 6) xor (e rightrotate 11) xor (e rightrotate 25)"
		t1 += ((e & f) ^ (~e & g));						// Wikipedia̋^ނ: "ch := (e and f) xor ((not e) and g)"
		t1 += h + K[uc_temp] + ul_message[s];			// Wikipedia̋^ނ: "t1 := h + s1 + ch + k[i] + w[i]"

		h = g;			// Wikipedia̋^ނ: "h := g"
		g = f;			// Wikipedia̋^ނ: "g := f"
		f = e;			// Wikipedia̋^ނ: "f := e"
		e = d + t1;		// Wikipedia̋^ނ: "e := d + t1"
		d = c;			// Wikipedia̋^ނ: "d := c"
		c = b;			// Wikipedia̋^ނ: "c := b"
		b = a;			// Wikipedia̋^ނ: "b := a2"
		a = t1 + t2;	// Wikipedia̋^ނ: "a := t1 + t2"
	}

	// Wikipedia̋^ނ: "Hj(i)= a..h + Hj(i-1)"
	for(uc_temp = 0; uc_temp < 8; uc_temp++)
	{
		ul_working[uc_temp] += ul_temp[uc_temp];
	}
}
