/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		CCADCTPʕ
 *
 *		݌vADC(CCADC)ł̌`Ԑݒƍ̎pPʕ
 *
 * \par pLq:
 *		AVR456: SB201̧ѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: $
 * $Date		: $  \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

#include "common.h"
#include "ccadc.h"
#include "watchdog.h"

/******************************************************************************
 S(َ̧)ϐ
******************************************************************************/

#ifdef COMPENSATE_FOR_ERROR_AFTER_POLARITY_SWITCH
int16_t iccBeforeCadpolChange;
#endif

volatile int32_t CCADC_accResult;
volatile int16_t CCADC_iccResult;

union CCADC_conversionFlag_union{
	uint8_t allFlags;
	struct{
		uint8_t accResultReady : 1 ;
		uint8_t iccResultReady :1 ;
		uint8_t regularCurrentDetected : 1 ;
		uint8_t polaritySwitchOccured : 1 ;
	};
} volatile CCADC_statusFlags = {0x00};

/******************************************************************************
 I֐l^錾
******************************************************************************/

static void CCADC_PolarityManager( void );

/*----------------------------------------------------------------------------*/
/*!	\brief CC-ADCƒd̍\ݒ
 *
 * ݐςƒd̗pϊԂłȂAdݒ肵܂B
 *
 * sĂꍇCC-ADCOFFɂĂъJnȂƂɒӂĂB
 *
 * CC-ADCɎg邽޷ެߓdQƊčZȂ΂Ȃ
 * ȂƂɒӂĂB
 *
 * \param	accConversionTime	[ACCT_128, ACCT_256, ACCT_512, ACCT_1024]
 * \param	rccSamplingInterval	[RSI_256, RSI_512, RSI_1024, RSI_2048]
 * \param	regularCurrentLevel	mAŗ^܂B
 *
 * \retval	Ȃ
 */
void CCADC_Init( CCADC_AccConvPeriod_t accConversionTime, CCADC_RccConvPeriod_t rccSamplingInterval, uint16_t regularCurrentLevel )
{
	// CC-ADC\ݒύX̏܂őҋ@
	//(O̕ύX̂߂Ɋׂۯ̈Ԃ̓҂)
	while( CADCSRA & (1<<CADUB) ){};

	// doݒ
	CADRC = BATTCUR_mA2RccTicks(regularCurrentLevel);

	// Ăё҂
	while( CADCSRA & (1<<CADUB) ){};

	// CC-ADCϊԁAd̎ԊuAɐޯĂI
	// : sꍇCC-ADCOFF
	CADCSRA = ((uint8_t)accConversionTime) | ((uint8_t)rccSamplingInterval) | (CCADC_POLARITY_POS<<CADPOL);
}

/*----------------------------------------------------------------------------*/
/*!	\brief CC-ADC̓`ԂI
 *
 * ȉI
 * - CCADC_DISABLE	(CC-ADC֎~A荞݂֎~ĉ)
 * - CCADC_IAC		(CC-ADCAuƗݐς̗ύX荞݂𐶐܂B)
 * - CCADC_IC		(CC-ADCAuϊ荞݂𐶐܂B)
 * - CCADC_ACC		(CC-ADCAݐϕϊ荞݂𐶐܂B)
 * - CCADC_RCC		(d܂B - ݐϊ킪邱ƂɒӂĂB)
 *
 * Ƌ֎~CC-ADC̍\ݒύXȂƂɒӂĂB͓
 * 荞݂̋Ƌ֎~邾łB
 *
 * CC-ADCɎg邽޷ެߓdQƊčZȂ΂Ȃ
 * ȂƂɒӂĂB
 *
 *	\param	mode	CC-ADCɐݒ肳铮
 */
void CCADC_SetMode( CCADC_modes_t mode )
{
	// Wait for synchronization between clock domains before initiating write
	while( CADCSRA & (1<<CADUB) ){};

	switch( mode )
	{
	case CCADC_DISABLE:		// CC-ADC֎~A荞݋֎~(ۗ荞݂)
		CADCSRA = CADCSRA & ~( (1<<CADEN) | (1<<CADSE) );
		CADCSRB = (0<<CADACIE) | (0<<CADRCIE) | (0<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);
		break;
		
	case CCADC_IAC:			// ICCACC̗荞ݑsƋCC-ADC(ۗ荞݂)
		CADCSRA = ( CADCSRA & ~(1<<CADSE) ) | (1<<CADEN);
		CADCSRB = (1<<CADACIE) | (0<<CADRCIE) | (1<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);
		break;

	case CCADC_ICC:			// ICC荞ݑsƋCC-ADC(ۗ荞݂)
		CADCSRA = ( CADCSRA & ~(1<<CADSE) ) | (1<<CADEN);
		CADCSRB = (0<<CADACIE) | (0<<CADRCIE) | (1<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);
		break;

	case CCADC_ACC:			// ACC荞ݑsƋCC-ADC(ۗ荞݂)
		CADCSRA = ( CADCSRA & ~(1<<CADSE) ) | (1<<CADEN);
		CADCSRB = (1<<CADACIE) | (0<<CADRCIE) | (0<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);
		break;

	case CCADC_RCC:			// RCCICC̊荞ݑsCC-ADC(RCCܰނ޲NȂICC)
		CADCSRA = CADCSRA | (1<<CADSE) | (1<<CADEN);
		CADCSRB = (0<<CADACIE) | (1<<CADRCIE) | (1<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);  
		break;

	default:
		break;
	}
}

/*----------------------------------------------------------------------------*/
/*!	\brief CC-ADCRCCIC/ACĈǂ̓삩̏񋟂܂B
 *
 * CC-ADCɎg邽޷ެߓdQƊčZȂ΂Ȃ
 * ȂƂɒӂĂB
 *
 *	\return	mode	[CCADC_RCC, CCADC_IAC]
 */
uint8_t CCADC_GetMode( void )
{
	//!< ǂݎԂɐ旧ĸۯ̈Ԃ̓҂
	while( CADCSRA & (1<<CADUB) ){};

	if( CADCSRA & (1<<CADSE) )
	{
		return CCADC_RCC;
	}
	else
	{
		return CCADC_IAC;
	}
}

/*----------------------------------------------------------------------------*/
/*!	\brief CC-ADCݐϕϊ̌ʂԂ܂B
 *	
 * ݐςꂽϊ̕t18ޯĂ̌ʂ𕄍t32ޯĂƂĕԂ܂Bʂ͂
 * ꂪԂOɕt24.8Œ菬_g悤Ɏړx܂B
 * 
 * CC-ADCɎg邽޷ެߓdQƊčZȂ΂Ȃ
 * ȂƂɒӂĂB
 *
 *	\return	t24.8Œ菬_`ōŐVCC-ADC ACČʂԂ܂B
 */
int32_t CCADC_GetAccResult( void )
{
	int32_t result;
	uint8_t interruptState = __save_interrupt();

	__disable_interrupt();
	result = CCADC_accResult;
	__restore_interrupt(interruptState);

	return result;
}

/*----------------------------------------------------------------------------*/
/*!	\brief CC-ADCuϊ̌ʂԂ܂B
 *
 * uϊ̕t13ޯĂ̌ʂ𕄍t18ޯĂƂĕԂ܂B
 *
 * CC-ADCɎg邽޷ެߓdQƊčZȂ΂Ȃ
 * ȂƂɒӂĂB
 *
 *	\return	ŐVCC-ADC ICC
 */
int32_t CCADC_GetIccResult( void )
{
	int16_t result;
	uint8_t interruptState = __save_interrupt();

	__disable_interrupt();
	result = CCADC_iccResult;
	__restore_interrupt(interruptState);

	return (int32_t)(result) * (1<<5);		// 13ޯĂICCʂݐόʂ悤18ޯĂɎړx
}

/*----------------------------------------------------------------------------*/
/*! \brief CC-ADC͋ɐύX鎞Ǘ
 *
 * CC-ADC͋ɐ\ref CONVERSION_COUNTϊɕς܂B͕ϊ\
 * Ȍ葬₩ɍsׂȂ̂ŁÅ֐ADCϊ荞ٰ݂ɑgݍ
 * ܂܂B͑̉PĂ΂ׂłȂA]ĐÓI/Ǐَ̧
 * płB
 */
#pragma inline = forced
static void CCADC_PolarityManager( void )
{
	static uint8_t polarityCounter = CONVERSION_COUNT;

	polarityCounter--;

	if(polarityCounter == 0)
	{
		// CADPOLύXOICClۑ
		// ͋ɐύX̍ŏICC(]āAACC)肪sȏꍇ̕⏞Ɏg
		// ܂B
#ifdef COMPENSATE_FOR_ERROR_AFTER_POLARITY_SWITCH
		{
			if( CCADC_IS_POLARITY_NEGATIVE() )
			{
				iccBeforeCadpolChange = -CADIC;
			}
			else
			{
				iccBeforeCadpolChange = CADIC;
			}
		}
#endif
		CADCSRA ^= (1<<CADPOL);
		polarityCounter = CONVERSION_COUNT;
		CCADC_statusFlags.polaritySwitchOccured = true;
	} else {
		CCADC_statusFlags.polaritySwitchOccured = false;
	}
}

/******************************************************************************/
/*! \brief VCC-ADCݐϓdʂ𔻒f̂Ɏgp
 *
 * 荞݂ɂē׸ނ౸邽߁A̱͂ɑS̊荞
 * ݂֎~邱Ƃɂĕی삳܂B
 *
 *	\return	VʂŐ^AȂ΋UԂ܂B
 */
bool CCADC_isAccResultReady( void )
{
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();

	bool flagState = CCADC_statusFlags.accResultReady;
	CCADC_statusFlags.accResultReady = false;

	__restore_interrupt( interruptState );

	return flagState;
}

/******************************************************************************/
/*! \brief VCC-ADCudʂ𔻒f̂Ɏgp
 *
 * 荞݂ɂē׸ނ౸邽߁A̱͂ɑS̊荞
 * ݂֎~邱Ƃɂĕی삳܂B
 *
 *	\return	VʂŐ^AȂ΋UԂ܂B
 */
bool CCADC_isIccResultReady( void )
{
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();

	bool flagState = CCADC_statusFlags.iccResultReady;
	CCADC_statusFlags.iccResultReady = false;

	__restore_interrupt( interruptState );

	return flagState;
}

/******************************************************************************/
/*! \brief ŌɊACCϊɋɐύXꂽ𒲍
 *
 * \retval	true	ŌɊꂽACCϊɋɐύX܂B
 * \retval	false	ŌɊꂽACCϊɋɐύXĂ܂B
 */
bool CCADC_GetPolarityChange( void )
{
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();

	bool flagState = CCADC_statusFlags.polaritySwitchOccured;

	__restore_interrupt( interruptState );

	return flagState;
}

/******************************************************************************/
/*! \brief ݐϕϊɑ΂鐶ψ(̾)Ԃ܂B
 *
 * ɐƐɐ̌ʂɂƂ܂B
 *
 * \note	͕ψʂvZĂȂꍇ32767Ԃ܂B
 *
 * \return	ݐϕϊɑ΂ψ
 */
int16_t CCADC_GetRawAccOffset( void )
{
	return accOffset;
}

/*****************************************************************************/
/*! \brief ݐϕϊɑ΂ψ(̾)Ԃ܂B
 *
 * ̊֐̕ԂlZꂽʂ̕ψʂ𓾂邽߂ɍŌ̕ϊ̌ʂɒ
 * Z邱Ƃł悤ɍŌ̕ϊ̋ɐ𒲍
 *
 * accOffsetvZĂȂ(32767)̏ꍇA0Ԃ܂B
 *
 * \return	Ō̓dɉZׂl
 */
int16_t CCADC_GetAccOffset( void )
{
	if(accOffset == 32767) {
		return 0;
	}
	bool polChange = CCADC_GetPolarityChange();
	if ( CCADC_IS_POLARITY_NEGATIVE() ) {
		if ( polChange ) {
			return -accOffset;
		} else {
			return accOffset;
		}
	} else {
		if( polChange ) {
			return accOffset;
		} else {
			return -accOffset;
		}
	}
}

/******************************************************************************/
/*! \brief ݐϕϊψ(̾)vZ
 *
 * ɐύX܂ł܂ǍɊeɐɑ΂lW߂ĕψʂvZ
 *
 * \note ׂ: 荞݂đSĂCPUÂɒʐMȂǂ͓܂
 *					 B܂_œdCCGASGPʕɑꂸÂɂ͔
 *					 ɒႢd̎ɂ点ׂłB
 *
 * \note XɏdvȒ: ̊֐鎞ɓd͈łȂ΂Ȃ܂!B
 *						 łȒPȉFET֎~邱ƂłB
 */
void CCADC_CalculateAccOffset( void )
{
	int16_t average;
	int16_t firstSampleAverage;
	int16_t secondSampleAverage;
	uint8_t values;

	// ɐύX҂
	while( ! CCADC_GetPolarityChange() ) {
		while( ! CCADC_isAccResultReady() ) {};
		WDT_ResetTimer();
	}
	// ɐ擾(Ôߓҋ@)
	while( CADCSRA & (1<<CADUB) ){};
	bool firstSampleNegative = CCADC_IS_POLARITY_NEGATIVE();

	// ɐύX̍ŏ̑lj
	while( ! CCADC_isAccResultReady() ) {};
	WDT_ResetTimer();

	// VɐύX܂Ŋelۑ
	values = 0;
	average = 0;
	while( ! CCADC_GetPolarityChange() ) {
		while( ! CCADC_isAccResultReady() ) {};
		WDT_ResetTimer();
		average += CCADC_GetAccResult();
		++values;
	}
	firstSampleAverage = average/values;

	// ɐύX̍ŏ̑lj
	while( ! CCADC_isAccResultReady() ) {};
	WDT_ResetTimer();

	// VɐύX܂Ŋelۑ
	values = 0;
	average = 0;
	while( ! CCADC_GetPolarityChange() ) {
		while( ! CCADC_isAccResultReady() ) {};
		WDT_ResetTimer();
		average += CCADC_GetAccResult();
		++values;
	}
	secondSampleAverage = average/values;

	accOffset = (firstSampleAverage-secondSampleAverage) / 2;
	if(firstSampleNegative)  {
		accOffset = -accOffset;
	}
}

/******************************************************************************/
/*! \brief CC-ADCudϊ荞
 */
#pragma vector= CCADC_CONV_vect
__interrupt void CCADC_Icc_ISR( void )
{
	//!< ǂݎԌɸۯ̈Ԃ̓ҋ@
	while( CADCSRA & (1<<CADUB) ){};

	if( CCADC_IS_POLARITY_NEGATIVE() )
	{
		CCADC_iccResult = -CADIC;
	}
	else
	{
		CCADC_iccResult = CADIC;
	}

	CCADC_statusFlags.iccResultReady = true;
}

/******************************************************************************/
/*! \brief CC-ADCd臒lʉߊ荞
 */
#pragma vector= CCADC_REG_CUR_vect
__interrupt void CCADC_Rcc_ISR( void )
{
	CCADC_statusFlags.regularCurrentDetected = true;
}

/******************************************************************************/
/*! \brief CC-ADCݐϓdϊ荞
 */
#pragma vector= CCADC_ACC_vect
__interrupt void CCADC_Acc_ISR( void )
{
	//!< ǂݎԌɸۯ̈Ԃ̓ҋ@
	while( CADCSRA & (1<<CADUB) ){};

	if( CCADC_IS_POLARITY_NEGATIVE() )
	{
		CCADC_accResult = - CADAC;
	}
	else
	{
		CCADC_accResult = CADAC;
	}

#ifdef COMPENSATE_FOR_ERROR_AFTER_POLARITY_SWITCH
	// polarityCounter1ɓꍇAꂪɐ؂ւ̍ŏ̕ϊ̂߁A
	// CCADC_accResultsɊi[ꂽdʂ͕⏞ׂłB
	if(CCADC_statusFlags.polaritySwitchOccured) {
		CCADC_accResult += (iccBeforeCadpolChange>>2);
	}
#endif

	CCADC_PolarityManager();
	CCADC_statusFlags.accResultReady = true;
}
