/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		͒PUARTײނçقłB
 *
 *		̧ق͒PĳUART̊SȎ܂݂܂BUART̍\ݒɂ
 *		ͯ ̧قBײނɂĕKvƂ銄荞݂𐶐
 *		̂Ɍvr荞݂ƊO荞݂g܂B
 *
 *		AVR274pLq̿ ނATmega16HVA@\ɕύXĂ܂B
 *
 * \par pLq:
 *		AVR456: SB201 HVA 1,2ٌdŗѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Name		: $
 * $Revision	: $
 * $Date		: $ \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

#include "common.h"
#include "sw_uart.h"			// UARTݒ޲w
#include "pwr_mgmnt.h"

/* vl */
#define UART_STATE_IDLE			0
#define RECEIVE_FIRST_DATA		3
#define RECEIVE_LAST_DATA		17
#define RECEIVE_STOP_1			19
#define RECEIVE_FINISH			23
#define TRANSMIT_START_BIT		2
#define TRANSMIT_FIRST_DATA		4
#define TRANSMIT_LAST_DATA		18
#define TRANSMIT_STOP			20
#define TRANSMIT_FINISH			22

/* ʐMϐ */
uint8_t SW_UART_status;				//!< ׸ނێ޲
uint8_t SW_UART_counter;			//!< v튄荞݂Ŏgvێ

static uint8_t UART_Tx_data;		//!< Mްێ޲
static uint8_t UART_Rx_data;		//!< Mްێ޲

static uint8_t UART_Next_TX_Bit;	//!< ׂޯĂɉ0x01܂0x00
static uint8_t UART_Last_TX_Bit;	//!< ŏIޯĂɉ0x01܂0x00

/* ɏՕ */

static uint8_t UART_Tx_buffer[UART_TX_BUFFER_SIZE];
static uint8_t UART_TxHead;
static uint8_t UART_TxTail;

static uint8_t UART_Rx_buffer[UART_RX_BUFFER_SIZE];
static uint8_t UART_RxHead;
static uint8_t UART_RxTail;

/* ^錾 */

static void SW_UART_Add_Data_To_TX_Buffer(uint8_t ch);
static bool SW_UART_Add_Data_To_RX_Buffer(uint8_t ch);
static uint8_t SW_UART_Get_Data_From_TX_Buffer();
static void SW_UART_Start_Transmission();

static bool SW_UART_TX_Buffer_Empty_inline();

/*! \brief UART
 *
 *  ̊֐͌vƊɏՕAްm邽߂ɊO荞݂
 *  ܂B̂ǂUART֐ĂԂ̂ɂ旧Ă̊֐𑖂点邱Ƃd
 *  vłBMް͎IRXɏՕɒu܂B
 *
 *  \note UART͌vƊO荞݂֎~邱ƂɂĒ~܂B
 */
void SW_UART_Enable(void)
{
	// ʐM݂Hi-Z
	INITIALIZE_UART_PIN();

	SW_UART_status = 0x00;
	SW_UART_counter = UART_STATE_IDLE;
	CLEAR_UART_TIMER_ON_COMPARE_MATCH();
	SET_UART_TIMER_16BIT_MODE();

	SET_UART_TIMER_COMPARE_WAIT_ONE();

	// 荞ݏ
	INITIALIZE_UART_EXTERNAL_INTERRUPT();	// O荞݂𐳂݂ł̊Jnޯē҂ɐݒ
	CLEAR_UART_EXTERNAL_INTERRUPT_FLAG();	// 闝R̂ߊɐݒ肳ĂꍇA׸ނ
	ENABLE_UART_EXTERNAL_INTERRUPT();
}

/*! \brief UART֎~
 *
 *  ̊֐͌v튄荞݂ƊO荞݂֎~邱ƂɂUART֎~
 *  B
 */
void SW_UART_Disable()
{
	SW_UART_status = 0x00;
	DISABLE_UART_TIMER_INTERRUPT();
	DISABLE_UART_EXTERNAL_INTERRUPT();
	STOP_UART_TIMER();
}

/*! SW_UART_Flush_Buffer()̲ײݔ
 */
#pragma inline=forced
static void SW_UART_Flush_Buffers_inline()
{
	UART_TxHead = 0;
	UART_TxTail = 0;
	UART_RxHead = 0;
	UART_RxTail = 0;
}

/*! \brief TXɏՕj
 */
void SW_UART_Flush_Buffers()
{
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();
	SW_UART_Flush_Buffers_inline();
	__restore_interrupt(interruptState);
}

/* \brief TXɏՕ޲Ăǉ
 *
 * TXɏՕ1޲Ăǉ܂BɏՕt̏ꍇ͉܂B
 */
void SW_UART_Add_Data_To_TX_Buffer(uint8_t ch)
{
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();

	uint8_t tmphead = (UART_TxHead + 1) & UART_TX_BUFFER_MASK;

	// ɏՕtłȂꍇɂǉ
	if(tmphead != UART_TxTail) {
		UART_Tx_buffer[tmphead] = ch;
		UART_TxHead = tmphead;
	}
	__restore_interrupt(interruptState);
}

/* \brief RXɏՕ޲Ăǉ
 *
 * RXɏՕ1޲Ăǉ܂Bްǉꂽꍇ͐^ARXɏՕt̏
 * ͋UԂ܂B
 *
 * \note x: S̊荞݋֎~ł̊֐ǂłB
 */
bool SW_UART_Add_Data_To_RX_Buffer(uint8_t ch)
{
	uint8_t tmphead;

	tmphead = UART_RxHead;

	tmphead = (tmphead + 1) & UART_RX_BUFFER_MASK;

	if(tmphead == UART_RxTail) {
		// ɏՕtAVԂ܂B
		return false;
	} else {
		// ɏՕްi[Đ擪ʒuwqXV
		UART_Rx_buffer[tmphead] = ch;
		UART_RxHead = tmphead;

		return true;
	}
}

/* \brief TXɏՕ󂩒
 */
bool SW_UART_TX_Buffer_Empty()
{
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();
	bool ret = SW_UART_TX_Buffer_Empty_inline();
	__restore_interrupt(interruptState);

	return ret;
}

/* \brief TXɏՕ󂩒
 *
 * xdvŕی삪svȏꍇ̊荞݂Ŏg߂̲ײ݉
 */
#pragma inline=forced
bool SW_UART_TX_Buffer_Empty_inline()
{
	return UART_TxHead == UART_TxTail;
}

/* \brief RXɏՕ󂩒
 */
bool SW_UART_RX_Buffer_Empty()
{
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();
	bool ret = UART_RxHead == UART_RxTail;
	__restore_interrupt(interruptState);

	return ret;
}

/*! \brief MɏՕ޲Ď擾
 *
 * ̊֐gOɊɏՕłȂƂ𒲂ׂĂBɏՕ̏ꍇA0
 * Ԃ܂B
 *
 * \return	TXɏՕ̍łÂ޲
 *
 */
uint8_t SW_UART_Get_Data_From_TX_Buffer()
{
	uint8_t ret = 0;
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();

	if( ! SW_UART_TX_Buffer_Empty_inline() ) {
		// Ōړ
		UART_TxTail = ( UART_TxTail + 1 ) & UART_TX_BUFFER_MASK;

		// ް擾
		ret = UART_Tx_buffer[UART_TxTail];
	}

	__restore_interrupt(interruptState);
	return ret;
}

/*! \brief 1޲đM
 *
 *  ̊֐͑MɏՕ1޲ĂǉAʐMق̏ꍇɑMJn܂B
 *
 *  \param	data	ׂް
 */
void SW_UART_Transmit(uint8_t data)
{
	if( ! READ_FLAG(SW_UART_status, SW_UART_DECLINE_NEW_TX_DATA) ) {
		SW_UART_Add_Data_To_TX_Buffer(data);

		// is̒ʐMȂΑMJn
		if( SW_UART_counter == UART_STATE_IDLE && READ_UART_PIN() )
		{
			// ɏՕ޲Ă𕡎ʂĊɏՕt׸ނ
			UART_Tx_data = SW_UART_Get_Data_From_TX_Buffer();

			SW_UART_Start_Transmission();
		}
	}
}

static void SW_UART_Start_Transmission()
{
	DISABLE_UART_EXTERNAL_INTERRUPT();
	uint8_t interruptState =__save_interrupt();
	__disable_interrupt();
	SW_UART_counter = TRANSMIT_START_BIT;			// Jnޯđô߂ɌvXV
	UART_Last_TX_Bit = 0x01;						// JnޯđoAͱفAHighłȂ΂Ȃ܂B
	UART_Next_TX_Bit = 0x00;
	STOP_UART_TIMER();
	CLEAR_UART_TIMER();								// v
	SET_UART_TIMER_VALUE(TIMER_START_TRANSMIT);		// \Ȍ葁v튄荞݂𓾂邽߁AvlrlO̐ɐݒ
	CLEAR_UART_TIMER_INTERRUPT_FLAG();				// v튄荞ݗv׸ނݒ肳ĂȂƂۏ
	ENABLE_UART_TIMER_INTERRUPT();
	START_UART_TIMER();								// vJn
	__restore_interrupt( interruptState );
}

/*! \brief RXɏՕްp\
 *
 * \return	ްp\ȏꍇɐ^AȂ΁AU
 */
bool SW_UART_Data_Available()
{
	bool ret;
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();
	ret = (UART_RxHead != UART_RxTail);
	__restore_interrupt(interruptState);
	return ret;
}

/*! \brief 1޲Ď擾
 *
 *  ̊֐RXɏՕ𱸾邱Ƃɂ1޲ĂްԂ܂BɏՕ
 *  ꍇ0Ԃ܂B
 *
 *  \return	Mް
 */
uint8_t SW_UART_Getchar()
{
	uint8_t ret = 0;
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();

	if( ! SW_UART_RX_Buffer_Empty() ) {
		uint8_t tmptail;

		// Ōړ
		tmptail = ( UART_RxTail + 1 ) & UART_RX_BUFFER_MASK;

		// ްԂ܂B
		ret = UART_Rx_buffer[tmptail];

		UART_RxTail = tmptail;
	}

	__restore_interrupt(interruptState);
	return ret;
}

/*! \brief O荞ݏٰ
 *
 *  JnޯĂ̎n܂ł̉~[̊荞݂N܂Bv튄荞݂͋
 *  Ax~삪ݒ肳AްĎMv킪ݒ肳܂B
 */
#pragma vector=SW_UART_EXTERNAL_INTERRUPT_VECTOR
__interrupt void External_SW_UART_ISR(void)
{
	// ޯĂLowł邱Ƃm
	if(!READ_UART_PIN())
	{
		SET_UART_TIMER_VALUE(TIMER_START_RECEIVE);
		START_UART_TIMER();

		CLEAR_UART_TIMER_INTERRUPT_FLAG();
		ENABLE_UART_TIMER_INTERRUPT();

		SW_UART_counter = RECEIVE_FIRST_DATA;
		UART_Rx_data = 0x00;
		DISABLE_UART_EXTERNAL_INTERRUPT();

		SLEEP_SET_IDLE_MODE();		// ق[ǂ̋x~ւ̓ȂƂۏ؂Ȃ΂Ȃ܂B

		INITIALIZE_UART_PIN();		// ʐMHi-Z
	}
}

/*! \brief vr荞ݏٰ
 *
 *  ̊荞݂͔rڼ޽vƓɋN܂Bv𑝂₵Ċe
 *  ޯĂ̑M܂B
 *
 *  \note WAIT_ONE`͊荞݂Ȃ悤Aٰ݂Ŕ₳ő厞
 *		  łȂ΂Ȃ܂B
 */
#pragma vector=SW_UART_TIMER_COMPARE_INTERRUPT_VECTOR
__interrupt void Timer_SW_UART_ISR(void)
{
	// UARTݏ̒l𒲂ׂ邱ƂɂޯĂ̎
	uint8_t bit_in = 0x00;
	if(READ_UART_PIN())		// : READ_UART_PIN()0x01/0x00Ԃ܂B
	{
		bit_in = 0x01;
	}

	////////////////////////////
	// v킪̏ꍇɎM
	////////////////////////////
	if(SW_UART_counter & 0x01)
	{
		// ް ޯĎMȂAMޯĂRx_dataɕ
		if(SW_UART_counter <= RECEIVE_LAST_DATA)
		{
			UART_Rx_data = ( UART_Rx_data >> 1 );	// RX_dataEޯĈړÂɐVKޯĂRX_dataŎՕ꓾܂B
			if(bit_in)
			{
				UART_Rx_data |= 0x80;				// Mޯ=1ȂARX_data̍ŏޯĂݒ(=1)
			}
		}

		// ~ޯĎMȂAMްMɏՕ֕
		else if(SW_UART_counter == RECEIVE_STOP_1)
		{
			CLEAR_UART_EXTERNAL_INTERRUPT_FLAG();
			ENABLE_UART_EXTERNAL_INTERRUPT();		// V޲ĎM

			// Low̒~ޯĎM̏ꍇڰшُ׸ނݒB܂ɏՕɂ܂B
			if(!bit_in)
			{
				SET_FLAG( SW_UART_status, SW_UART_FRAME_ERROR );
				SW_UART_Flush_Buffers_inline();
				DISABLE_UART_TIMER_INTERRUPT();
				SW_UART_counter = UART_STATE_IDLE;
				SET_FLAG(SW_UART_status, SW_UART_DECLINE_NEW_TX_DATA);
				return;

			} else {
				// }s̏ꍇAɏՕtŁÂɊɏՕ׸ނݒ
				if( ! SW_UART_Add_Data_To_RX_Buffer( UART_Rx_data ) ) {
					SET_FLAG( SW_UART_status, SW_UART_RX_BUFFER_OVERFLOW );
				}
			}

			SET_FLAG( SW_UART_status, SW_UART_RX_COMPLETE );

			// ޲͂ꂪbقǂ蓾邽߁Aŏɂ޲Ăɋx
			// ~ׂ֓ł͂܂B
			SLEEP_DISABLE();
		}

		// MIŐVKްoȂȂA
		else if(SW_UART_counter == RECEIVE_FINISH)
		{
			// ȉ̏ꍇɑMJn
			// - ʐMُ
			// - ڰшُ͋NĂȂB
			// - TXɏՕްL
			if( READ_UART_PIN() && ! READ_FLAG(SW_UART_status, SW_UART_FRAME_ERROR) && ! SW_UART_TX_Buffer_Empty_inline() )
			{
				UART_Tx_data = SW_UART_Get_Data_From_TX_Buffer();
				SW_UART_Start_Transmission();
				return;								// ISRoÂɌv͍XV܂B
			}

			// TXɏՕɑM҂ްȂȂAقɐݒ肵Ċ荞݂֎~
			// ܂BO荞݂͖Jn܂B
			else
			{
				DISABLE_UART_TIMER_INTERRUPT();
				SW_UART_counter = UART_STATE_IDLE;
				return;								// ISRoÂɌv͍XV܂B
			}
		}
	}

	//////////////////////////////
	// v킪̏ꍇɑM
	//////////////////////////////
	else
	{
		// HighޯĂ𑗂LowMꍇAM𒆒fĊɏՕɂ܂B
		if( UART_Last_TX_Bit != bit_in )
		{
			SW_UART_Flush_Buffers_inline();
			INITIALIZE_UART_PIN();					// ʐMHi-Z
			SW_UART_counter = RECEIVE_FIRST_DATA;
			UART_Rx_data = 0x00;
			return;
		}

		// ޯđM
		if( UART_Next_TX_Bit )
		{
			SET_UART_PIN();
		}
		else
		{
			CLEAR_UART_PIN();
		}

		// ŏIޯđoݒ
		UART_Last_TX_Bit = UART_Next_TX_Bit;

		// JnޯĂxoꂽȂAޯĂŏް ޯĂɐݒ
		if(SW_UART_counter == TRANSMIT_START_BIT) {
			UART_Next_TX_Bit = UART_Tx_data & 0x01;
			DISABLE_UART_EXTERNAL_INTERRUPT();

			// 1ް ޯĂxoꂽȂAް ޯĂEړĐVޯĂݒ
		} else if(SW_UART_counter < TRANSMIT_LAST_DATA) {
			UART_Tx_data = UART_Tx_data >> 1;
			UART_Next_TX_Bit = (UART_Tx_data & 0x01);

			// ŏIް ޯĂxoꂽȂAޯĂ~ޯĂɐݒ
		} else if(SW_UART_counter == TRANSMIT_LAST_DATA) {
			UART_Next_TX_Bit = 0x01;

			// ~ޯĂxoꂽȂAO荞݂
		} else if(SW_UART_counter == TRANSMIT_STOP) {
			CLEAR_UART_EXTERNAL_INTERRUPT_FLAG();
			ENABLE_UART_EXTERNAL_INTERRUPT();
			// UART_Next_TX_Bit͊0x01ɐݒ

			// MIꂽȂA޲đoA܂ͱق֖߂܂B
		} else {
			// TX_bufferްLΑMJn
			if( ! SW_UART_TX_Buffer_Empty_inline()  )
			{
				SW_UART_counter = TRANSMIT_START_BIT;
				UART_Tx_data = SW_UART_Get_Data_From_TX_Buffer();
				// JnޯĂ𑗏o鎞͐فAHighłȂ΂Ȃ܂B
				UART_Last_TX_Bit = 0x01;
				UART_Next_TX_Bit = 0x00;
				SET_UART_TIMER_VALUE(0);
				CLEAR_UART_TIMER_INTERRUPT_FLAG();
			}

			// TXɏՕɑM҂ްȂȂAقɐݒ肵Ċ荞݂֎~
			// ܂BO荞݂͖sĂ܂B
			else
			{
				DISABLE_UART_TIMER_INTERRUPT();
				SW_UART_counter = UART_STATE_IDLE;
			}

			return; // oÂISR͍XV܂B
		}
	}

	SW_UART_counter = SW_UART_counter + 2;		// vXV
}
