/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		drٓdḐ̌ѳPʕ
 *
 * \par pLq:
 *		AVR456: SB201̧ѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: $
 * $Date		: $ \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

/******************************************************************************
 ݸٰ ̧
******************************************************************************/
#include "common.h"
#include "battery_voltage_monitoring.h"
#include "vadc.h"
#include "battery_pack_parameters.h"

/******************************************************************************
 ֐錾
******************************************************************************/

/******************************************************************************/
/*! \brief drقႷ邩
 *
 * V-ADCĂ邱ƂKvƂ܂B
 *
 *	\param	cell	ׂفB ̊֐ɂĒׂ܂񂪁Aق
 *					ꍇreadCellVoltage0Ԃ܂(]Ă̊֐͂̏
 *					Aɐ^Ԃ܂)B
 *
 *	\return	ق̂ǂꂩႷdꍇɐ^ԂAȂ΋UłB
 */
bool BATTVMON_IsCellVoltageTooLow( vadcIndex_t cell )
{
	if( battParams.cellMinVoltage > VADC_readCellVoltage( cell ) ){
		return true;		// ق̓dႷłB

	} else {
		return false;
	}
}

/******************************************************************************/
/*! \brief drق̂ǂꂩ
 *
 * V-ADCĂ邱ƂKvƂ܂B
 *
 *	\param	cell	ׂفB ̊֐ɂĒׂ܂񂪁Aق
 *					ꍇreadCellVoltage0Ԃ܂(]Ă̊֐͂̏
 *					Aɐ^Ԃ܂)B
 *
 *	\return	ق̂ǂꂩdꍇɐ^ԂAȂ΋UłB
 */
bool BATTVMON_IsCellVoltageTooHigh( vadcIndex_t cell )
{
	if( battParams.cellMaxVoltage < VADC_readCellVoltage( cell ) ){
		return true;		// ق̓dłB

	} else {
		return false;
	}
}

/****************************************************
 ****************************************************

 ̊֐͒񕡐ِpłB

 ****************************************************
 ****************************************************/

#if BATTPARAM_CELLS_IN_SERIES >= 2
/******************************************************************************/
/*! \brief ٕt: stAȂξٕtFET̂ǂꂩ
 */
void BATTVMON_EnableCellBalancing( void )
{
	uint16_t cell1 = VADC_readCellVoltage( CELL1 );
	uint16_t cell2 = VADC_readCellVoltage( CELL2 );
	uint16_t misbalanceVoltageThreshold = battParams.misbalanceVoltageThreshold;

	if( cell1 > ( cell2 + misbalanceVoltageThreshold)){ 
		BALANCING_FET2_PORT &= ~(1<<FET2);
		BALANCING_FET1_PORT |= (1<<FET1);
	}
	else if( cell2 > ( cell1 + misbalanceVoltageThreshold)){ 
		BALANCING_FET1_PORT &= ~(1<<FET1);
		BALANCING_FET2_PORT |= (1<<FET2);
	}
}

/******************************************************************************/
/*! \brief tFET֎~(ȂΓ)
 */
void BATTVMON_DisableCellBalancing( void )
{
	BALANCING_FET1_PORT &= ~(1<<FET1);
	BALANCING_FET2_PORT &= ~(1<<FET2);
}

/******************************************************************************/
/*! \brief tݏ
 */
void BATTVMON_InitializeBalancing()
{
	BALANCING_FET1_DDR |= (1<<FET1);
	BALANCING_FET2_DDR |= (1<<FET2);
}

/******************************************************************************/
/*! \brief tFET()ǂɂĂ̏
 *
 * \retval	bool	tFET̂ǂꂩ()Ăΐ^Ԃ܂B
 */
bool BATTVMON_IsCellBalancingEnabled( void )
{
	bool status = false;

	if( BALANCING_FET1_PORT & (1<<FET1)){
		status = true;
	}
	if( BALANCING_FET2_PORT & (1<<FET2)){
		status = true;
	}

	return status;
}

#endif
